PagedResultsControl (Java SE 26 & JDK 26)
Description: declaration: module: java.naming, package: javax.naming.ldap, class: PagedResultsControl
Keywords: javax.naming.ldap.PagedResultsControl class

# Class PagedResultsControl

java.lang.Object
javax.naming.ldap.BasicControl
javax.naming.ldap.PagedResultsControl

All Implemented Interfaces:
  `Serializable, Control`

public final class PagedResultsControl extends BasicControl
Requests that the results of a search operation be returned by the LDAP server in batches of a specified size. The requestor controls the rate at which batches are returned by the rate at which it invokes search operations.

The following code sample shows how the class may be used:

        // Open an LDAP association
        LdapContext ctx = new InitialLdapContext();

        // Activate paged results
        int pageSize = 20; // 20 entries per page
        byte[] cookie = null;
        int total;
        ctx.setRequestControls(new Control[]{
            new PagedResultsControl(pageSize, Control.CRITICAL) });

        do {
            // Perform the search
            NamingEnumeration results =
                ctx.search("", "(objectclass=*)", new SearchControls());

            // Iterate over a batch of search results
            while (results != null && results.hasMore()) {
                // Display an entry
                SearchResult entry = (SearchResult)results.next();
                System.out.println(entry.getName());
                System.out.println(entry.getAttributes());

                // Handle the entry's response controls (if any)
                if (entry instanceof HasControls) {
                    // ((HasControls)entry).getControls();
                }
            }
            // Examine the paged results control response
            Control[] controls = ctx.getResponseControls();
            if (controls != null) {
                for (int i = 0; i < controls.length; i++) {
                    if (controls[i] instanceof PagedResultsResponseControl) {
                        PagedResultsResponseControl prrc =
                            (PagedResultsResponseControl)controls[i];
                        total = prrc.getResultSize();
                        cookie = prrc.getCookie();
                    } else {
                        // Handle other response controls (if any)
                    }
                }
            }

            // Re-activate paged results
            ctx.setRequestControls(new Control[]{
                new PagedResultsControl(pageSize, cookie, Control.CRITICAL) });
        } while (cookie != null);

        // Close the LDAP association
        ctx.close();
        ...

This class implements the LDAPv3 Control for paged-results as defined in RFC 2696. The control's value has the following ASN.1 definition:

        realSearchControlValue ::= SEQUENCE {
            size      INTEGER (0..maxInt),
                              -- requested page size from client
                              -- result set size estimate from server
            cookie    OCTET STRING
        }

Since:
  1.5
See Also:
  - `PagedResultsResponseControl`
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `OID`
  The paged-results control's assigned object identifier is 1.2.840.113556.1.4.319.

  ### Fields declared in class BasicControl

  `criticality, id, value`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `criticality`
  The control's criticality.
  `protected String`
  `id`
  The control's object identifier string.
  `protected byte[]`
  `value`
  The control's ASN.1 BER encoded value.

  ### Fields declared in interface Control

  `CRITICAL, NONCRITICAL`
  Modifier and Type
  Field
  Description
  `static final boolean`
  `CRITICAL`
  Indicates a critical control.
  `static final boolean`
  `NONCRITICAL`
  Indicates a non-critical control.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PagedResultsControl(int pageSize, boolean criticality)`
  Constructs a control to set the number of entries to be returned per page of results.
  `PagedResultsControl(int pageSize, byte[] cookie, boolean criticality)`
  Constructs a control to set the number of entries to be returned per page of results.

- ## Method Summary

  ### Methods declared in class BasicControl

  `getEncodedValue, getID, isCritical`
  Modifier and Type
  Method
  Description
  `byte[]`
  `getEncodedValue()`
  Retrieves the control's ASN.1 BER encoded value.
  `String`
  `getID()`
  Retrieves the control's object identifier string.
  `boolean`
  `isCritical()`
  Determines the control's criticality.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### OID

    public static final String OID
    The paged-results control's assigned object identifier is 1.2.840.113556.1.4.319.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### PagedResultsControl

    public PagedResultsControl(int pageSize, boolean criticality) throws IOException
    Constructs a control to set the number of entries to be returned per page of results.
    Parameters:
      `pageSize` - The number of entries to return in a page.
      `criticality` - If true then the server must honor the control and return search results as indicated by pageSize or refuse to perform the search. If false, then the server need not honor the control.
    Throws:
      `IOException` - If an error was encountered while encoding the supplied arguments into a control.

  - ### PagedResultsControl

    public PagedResultsControl(int pageSize, byte[] cookie, boolean criticality) throws IOException
    Constructs a control to set the number of entries to be returned per page of results. The cookie is provided by the server and may be obtained from the paged-results response control.

    A sequence of paged-results can be abandoned by setting the pageSize to zero and setting the cookie to the last cookie received from the server.

    Parameters:
      `pageSize` - The number of entries to return in a page.
      `cookie` - A possibly null server-generated cookie.
      `criticality` - If true then the server must honor the control and return search results as indicated by pageSize or refuse to perform the search. If false, then the server need not honor the control.
    Throws:
      `IOException` - If an error was encountered while encoding the supplied arguments into a control.